/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the YoutubeAnalyticsControllerActionPlaylistRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &YoutubeAnalyticsControllerActionPlaylistRequest{}

// YoutubeAnalyticsControllerActionPlaylistRequest struct for YoutubeAnalyticsControllerActionPlaylistRequest
type YoutubeAnalyticsControllerActionPlaylistRequest struct {
	OAuthId   *string `json:"oAuthId,omitempty"`
	ChannelId *string `json:"channelId,omitempty"`
}

// NewYoutubeAnalyticsControllerActionPlaylistRequest instantiates a new YoutubeAnalyticsControllerActionPlaylistRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewYoutubeAnalyticsControllerActionPlaylistRequest() *YoutubeAnalyticsControllerActionPlaylistRequest {
	this := YoutubeAnalyticsControllerActionPlaylistRequest{}
	return &this
}

// NewYoutubeAnalyticsControllerActionPlaylistRequestWithDefaults instantiates a new YoutubeAnalyticsControllerActionPlaylistRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewYoutubeAnalyticsControllerActionPlaylistRequestWithDefaults() *YoutubeAnalyticsControllerActionPlaylistRequest {
	this := YoutubeAnalyticsControllerActionPlaylistRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *YoutubeAnalyticsControllerActionPlaylistRequest) SetChannelId(v string) {
	o.ChannelId = &v
}

func (o YoutubeAnalyticsControllerActionPlaylistRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o YoutubeAnalyticsControllerActionPlaylistRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channelId"] = o.ChannelId
	}
	return toSerialize, nil
}

type NullableYoutubeAnalyticsControllerActionPlaylistRequest struct {
	value *YoutubeAnalyticsControllerActionPlaylistRequest
	isSet bool
}

func (v NullableYoutubeAnalyticsControllerActionPlaylistRequest) Get() *YoutubeAnalyticsControllerActionPlaylistRequest {
	return v.value
}

func (v *NullableYoutubeAnalyticsControllerActionPlaylistRequest) Set(val *YoutubeAnalyticsControllerActionPlaylistRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableYoutubeAnalyticsControllerActionPlaylistRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableYoutubeAnalyticsControllerActionPlaylistRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableYoutubeAnalyticsControllerActionPlaylistRequest(val *YoutubeAnalyticsControllerActionPlaylistRequest) *NullableYoutubeAnalyticsControllerActionPlaylistRequest {
	return &NullableYoutubeAnalyticsControllerActionPlaylistRequest{value: val, isSet: true}
}

func (v NullableYoutubeAnalyticsControllerActionPlaylistRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableYoutubeAnalyticsControllerActionPlaylistRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
